#include <stdio.h>
#include <stdlib.h>

#define ESC 27
#define gotoxy(x,y) 		printf("\033[%d;%df",y,x) ; 
#define clrscr() 			printf("%c[2J%c[?6h", ESC, ESC);

#define NMAX	5


struct listagem{															//declarcao da lista
		char clube[20];
		int vitorias;
		int derrotas;
		int empates;
		int golsmarcados;
		int golssofridos;
		int pontos;
		};

//Definio dos estados possiveis de operao do programa
#define NENHUM			0
#define CLUBES			1
#define JOGOS			2
#define RESULTADOS	4
#define FIM				5

#define ERRO_USO		1
#define ERRO_ARQ		2
#define ERRO_JOGOS	3


char *trata_clubes(char *s)
{
	unsigned char i=0;
	//tira os espacos do inicio e do fim
	while(isalnum(s[i])==0)
		i++;
	s=&s[i];
	i=strlen(s);
	while(isalnum(s[i])==0)
		i--;
	s[i+1]='\0';
	return(s);
}

char *trata_jogos(char *s)
{
	unsigned int i=0;

	if(strlen(s)>0)
	{
		//tira os espacos do inicio e do fim
		while(isalnum(s[i])==0)
			i++;
		s=&s[i];
		i=strlen(s);
		while(isalnum(s[i])==0 && s[i]!='-')
			i--;
		s[i+1]='\0';
	}

	return(s);
}
//recebe um ponteiro para o inicio do array de estruturas de clubes do compeonato
//e o numero de clebes participantes
//calcula os pontos de cada clube e grava na estrutura
void calcula_pontos(struct listagem *camp,unsigned int num_clubes)
{
	unsigned int i;
	for(i=0;i<num_clubes;i++)
	{
		camp[i].pontos=(camp[i].vitorias)*3+(camp[i].empates);
	}

}
//recebe um ponteiro para o inicio do array de estruturas de clubes do compeonato,
//o numero de clubes participantes
//calcula os pontos de cada clube e grava na estrutura
//procura por pontuacao de zero ate o ultimo colocado
void classificacao(struct listagem *camp,unsigned int num_clubes, unsigned int *colocacao)
{
	unsigned int i=0,j=0,k=0,l=0;
	unsigned int pontos=0;
	unsigned int n=0,temp=0;
	
	while(n<num_clubes)
	{
		pontos=camp[j].pontos;
		for(j=0;j<num_clubes;j++)
		{
			if(camp[j].pontos==i)
			{
				n++;
				colocacao[k++]=j;
			}
		}	
		i++;
	}
}
//analisa o resultado dos jogos
//recebe uma linha de texto, um ponteiro para a listagem de clubes e o numero de clubes
//retorna 0 se o jogo nao foi realizado e 1 caso contrario
//identifica erro e sai se encontrar um clube nao listado
int analisa_jogos(char *s, struct listagem *camp, unsigned int n)
{
	int i,j,c1,c2;
	char saux1[20];
	char saux2[20];
	char *p;
	int golsmarcadosc1;
	int golsmarcadosc2;

	//trata o caso de jogos naum realizados
	if(strstr(s," - ")!=NULL)
	{
		return(0);
	}

	//separa a string em duas: "clube golsx" e "clube golsx"
	p=strstr(s,"gols");
	p=p+4;
	i=0;
	while(p[i]!=' ')
		i++;
	strcpy(saux1,s);
	saux1[p-s+i]='\0';
	strcpy(saux2,p+i+1);
	//verifica qual o clube em saux1
	for(c1=0;(c1<=n && !strstr(saux1,camp[c1].clube));c1++);
	//verifica qual o clube em saux2
	for(c2=0;(c2<=n && !strstr(saux2,camp[c2].clube));c2++);
	
	if(c1>=n||c2>=n)
	{
		printf("ERRO, clube nao listado no jogo %s\n",s);
		exit(ERRO_JOGOS);
	}
	//verifica se saux1 e saux2 naum sao o mesmo time
	if(c1==c2)
	{
		printf("ERRO, clube jogando sozinho em %s\n",s);
		exit(ERRO_JOGOS);
	}

	//verifica o numero de gols marcados pela equipe em saux1
	p=strstr(saux1,"gols");
	p=p+4;
	golsmarcadosc1=atoi(p);
	camp[c1].golsmarcados+=golsmarcadosc1;
	camp[c2].golssofridos+=golsmarcadosc1;
	
	//verifica o numero de gols marcados pela equipe em saux2
	p=strstr(saux2,"gols");
	p=p+4;
	golsmarcadosc2=atoi(p);
	camp[c2].golsmarcados+=golsmarcadosc2;
	camp[c1].golssofridos+=golsmarcadosc2;
	
	//analise do numero de gols
	if(golsmarcadosc1==golsmarcadosc2)
	{	
		camp[c1].empates++;
		camp[c2].empates++;
	}
	else if(golsmarcadosc1>golsmarcadosc2)
	{	
		camp[c1].vitorias++;
		camp[c2].derrotas++;
	}
	else
	{
		camp[c2].vitorias++;
		camp[c1].derrotas++;
	}
	return(1);
}

//retira /n 
char *cigets(char *buffer, int size, FILE *stream)
{
	int i;
	for(i=0;i<=128;i++)
		buffer[i]='\0';
	buffer=fgets(buffer,size,stream);
	if(buffer!=NULL)
	{
		for(i=strlen(buffer);buffer[i]!='\n';i--);
		buffer[i]='\0';
	}

	return(buffer);
}

int main(int argc, char *argv[])
{
	FILE *file;
	struct listagem campeonato[NMAX];
	char file_name[20];
	char line[128];
	char **clubes;
	char estado=NENHUM;
	unsigned int colocacao[NMAX];
	unsigned int i=0;
	unsigned int num_clubes=0;
	unsigned int num_jogos=0;
	unsigned int temp;
	
	if(argc<2)
	{	
		printf("Uso: %s [-h] [\"nome do arquivo do campeonato\"]\n\r",argv[0]);
		exit(ERRO_USO);
	}  
	
	if(strstr(argv[1],"-h"))
	{	
		printf("Uso: %s [-h] [\"nome do arquivo do campeonato\"]\n\r",argv[0]);
		printf("-O arquivo deve conter no maximo 128 clubes;\n");
		printf("-Nao deve ser usado o caractere de tabulacao horizontal;\n");
		printf("-Outras caracteristicas do software sao encontradas na especificacao do trabalho.\n");
		printf("\nOBS:\n");
		printf("-O programa ordena em ordem crescente de pontos;\n");
		printf("-fico devendo a verificacao dos clubes que jogam; \n");
		printf("-fico devendo pra proxima a ordenacao por gols marcados, pq deixei tudo pro ultima hora :)\n");
		printf("-TCHAU!!! \n");
		
		exit(ERRO_USO);
	}  

	memset(campeonato,0,NMAX*sizeof(struct listagem));
	strcpy(file_name, argv[1]);
	printf("Campeonato: %s\n\r",file_name);
	file=fopen(file_name,"r");
	if(file==NULL)
	{
		printf("Erro lendo arq %s\n",argv[1]);
		exit(ERRO_ARQ);
	}
	
	//procura o inicio da listagem dos clubes
	cigets(line,126,file);
	while(!feof(file)&&(strstr(line,"[CLUBES]")==NULL))
	{
		cigets(line,126,file);
	}
	
	//lista os clubes, ate achar o inicio dos jogos
	i=0;
	while(!feof(file)&&(strstr(line,"[JOGOS]")==NULL))
	{
		cigets(line,126,file);
		if((strstr(line,"[JOGOS]")==NULL)&&strlen(line)>0)
			strcpy(campeonato[i++].clube,trata_clubes(line));
	}
	
	num_clubes=i;

	//lista os jogos ate o fim do arquivo
	while(!feof(file))
	{
		cigets(line,126,file);
		if(strlen(line)>0)
		{
			num_jogos+=analisa_jogos(trata_jogos(line),campeonato, num_clubes);
		}
	}
	 
	//verifica se todoss os clubes jogam
/*	fseek(file,0,SEEK_SET);
	cigets(line,126,file);
	while(!feof(file)&&(strstr(line,"[JOGOS]")==NULL))
	{
		cigets(line,126,file);
	}
	while(!feof(file))
	{
		cigets(line,126,file);
		for(i=0;i<num_clubes;i++)
			if(strstr(line,campeonato[i].clube))
				temp=1;
	}
*/	
	calcula_pontos(campeonato,num_clubes);
	classificacao(campeonato,num_clubes,colocacao);
	clrscr();
	gotoxy(0,0);
	printf("CLUBES");
	gotoxy(21,0);
	printf("\tVIT\t\tEMP\t\tDER\t\tGM\t\tGS\t\tPONTOS");

	for(i=0;i<num_clubes;i++)
	{
		gotoxy(0,i+2);
		printf("%s",			campeonato[colocacao[i]].clube);
		gotoxy(21,i+2);
		printf("\t%d\t\t%d\t\t%d\t\t%d\t\t%d\t\t%d",
									campeonato[colocacao[i]].vitorias,
									campeonato[colocacao[i]].derrotas,
									campeonato[colocacao[i]].empates,
									campeonato[colocacao[i]].golsmarcados,
									campeonato[colocacao[i]].golssofridos,
									campeonato[colocacao[i]].pontos);

	}

	
	printf("\n\nClubes:%d\nJogos:%d",num_clubes,num_jogos);
	temp=0;
	for(i=0;i<num_clubes;i++)
		temp+=campeonato[i].golsmarcados;
	printf("\nMedia de gols por partida:%0.2f",(float)temp/num_jogos);
	printf("\nFIM\n");
	
	fclose(file);
	return 0;
}
